Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/PersistenceException.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/PersistenceException.cs	(revision 14927)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/PersistenceException.cs	(revision 14927)
@@ -0,0 +1,90 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Runtime.Serialization;
+using System.Text;
+
+namespace HeuristicLab.Persistence {
+
+  /// <summary>
+  /// Exception thrown by components inside the persistence framework.
+  /// </summary>
+  [Serializable]
+  public class PersistenceException : Exception {
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="PersistenceException"/> class.
+    /// </summary>
+    public PersistenceException() : base() { }
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="PersistenceException"/> class.
+    /// </summary>
+    /// <param name="message">The message.</param>
+    public PersistenceException(string message) : base(message) { }
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="PersistenceException"/> class.
+    /// </summary>
+    /// <param name="message">The message.</param>
+    /// <param name="innerException">The inner exception.</param>
+    public PersistenceException(string message, Exception innerException) :
+      base(message, innerException) { }
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="PersistenceException"/> class.
+    /// </summary>
+    /// <param name="message">The message.</param>
+    /// <param name="innerExceptions">The inner exceptions.</param>
+    public PersistenceException(string message, IEnumerable<Exception> innerExceptions)
+      : base(message) {
+      int i = 0;
+      foreach (var x in innerExceptions) {
+        i += 1;
+        this.Data.Add("Inner Exception " + i, x);
+      }
+    }
+
+    protected PersistenceException(SerializationInfo info, StreamingContext context) : base(info, context) { }
+
+    /// <summary>
+    /// Returns a <see cref="System.String"/> that represents this instance.
+    /// </summary>
+    /// <returns>
+    /// A <see cref="System.String"/> that represents this instance.
+    /// </returns>
+    /// <PermissionSet>
+    /// 	<IPermission class="System.Security.Permissions.FileIOPermission, mscorlib, Version=2.0.3600.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" version="1" PathDiscovery="*AllFiles*"/>
+    /// </PermissionSet>
+    public override string ToString() {
+      var sb = new StringBuilder()
+        .Append(base.ToString())
+        .Append('\n');
+      foreach (Exception x in Data.Values) {
+        sb.Append(x.ToString()).Append('\n');
+      }
+      return sb.ToString();
+    }
+  }
+
+}
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs	(revision 14927)
@@ -26,5 +26,4 @@
 using System.Linq;
 using Google.ProtocolBuffers;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
 
@@ -50,19 +49,4 @@
       foreach (var transformer in ApplicationManager.Manager.GetInstances<ITransformer>())
         RegisterTransformer(transformer);
-
-
-      // 
-      //  
-      //  
-      //  
-      //  
-      //  
-      //  
-      //  
-      //  
-      //  
-      //  "0F24C888-AF34-4318-9472-187B9AA85F3C"
-
-
 
       RegisterType(new Guid("ECAEA154-6BFF-419F-8BE6-2565E9314825"), typeof(object));
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableAttribute.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableAttribute.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableAttribute.cs	(revision 14927)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,13 +21,14 @@
 
 using System;
+using System.Reflection;
 using System.Text;
 
-namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable {
+namespace HeuristicLab.Persistence {
 
 
   /// <summary>
   /// Mark the member of a class to be considered by the <c>StorableSerializer</c>.
-  /// The class must be marked as <c>[StorableClass]</c> and the
-  /// <c>StorableClassType</c> should be set to <c>MarkedOnly</c> for
+  /// The class must be marked as <c>[StorableClass("05FE6F11-87C6-435E-800A-166AFACCF5AC")]</c> and the
+  /// <c>StorableMemberSelection</c> should be set to <c>MarkedOnly</c> for
   /// this attribute to kick in.
   /// </summary>
@@ -37,4 +38,10 @@
     Inherited = false)]
   public class StorableAttribute : Attribute {
+    public static bool IsStorable(MemberInfo memberInfo) {
+      return Attribute.IsDefined(memberInfo, typeof(StorableAttribute), false);
+    }
+    public static StorableAttribute GetStorableAttribute(MemberInfo memberInfo) {
+      return (StorableAttribute)Attribute.GetCustomAttribute(memberInfo, typeof(StorableAttribute), false);
+    }
 
     /// <summary>
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConstructorAttribute.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConstructorAttribute.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConstructorAttribute.cs	(revision 14927)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,6 +21,7 @@
 
 using System;
+using System.Reflection;
 
-namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable {
+namespace HeuristicLab.Persistence {
 
 
@@ -34,4 +35,8 @@
   /// </summary>
   [AttributeUsage(AttributeTargets.Constructor, Inherited = false, AllowMultiple = false)]
-  public sealed class StorableConstructorAttribute : Attribute { }
+  public sealed class StorableConstructorAttribute : Attribute {
+    public static bool IsStorableConstructor(ConstructorInfo constructorInfo) {
+      return Attribute.IsDefined(constructorInfo, typeof(StorableConstructorAttribute));
+    }
+  }
 }
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConversionAttribute.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConversionAttribute.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableConversionAttribute.cs	(revision 14927)
@@ -28,6 +28,5 @@
     public uint SrcVersion { get; set; }
 
-    public StorableConversionAttribute(uint srcVersion)
-    {
+    public StorableConversionAttribute(uint srcVersion) {
       this.SrcVersion = srcVersion;
     }
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableHookAttribute.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableHookAttribute.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StorableHookAttribute.cs	(revision 14927)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -21,6 +21,8 @@
 
 using System;
+using System.Linq;
+using System.Reflection;
 
-namespace HeuristicLab.Persistence.Default.CompositeSerializers.Storable {
+namespace HeuristicLab.Persistence {
 
 
@@ -49,5 +51,12 @@
   /// </summary>
   [AttributeUsage(AttributeTargets.Method, Inherited = false, AllowMultiple = true)]
+  [StorableType("983bf558-1458-4129-b018-7e121ac3840e")]
   public sealed class StorableHookAttribute : Attribute {
+    public static bool IsStorableHook(MethodInfo methodInfo) {
+      return Attribute.IsDefined(methodInfo, typeof(StorableHookAttribute), false);
+    }
+    public static StorableHookAttribute[] GetStorableHookAttributes(MethodInfo methodInfo) {
+      return Attribute.GetCustomAttributes(methodInfo, false).OfType<StorableHookAttribute>().ToArray();
+    }
 
     private readonly HookType hookType;
@@ -64,5 +73,5 @@
     /// at the <c>HookType</c> time.
     /// </summary>
-    /// <param name="hookType">Type of the hook.</param>
+    /// <param name="hookType">MemberSelection of the hook.</param>
     public StorableHookAttribute(HookType hookType) {
       this.hookType = hookType;
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/TypeInfo.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/TypeInfo.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/TypeInfo.cs	(revision 14927)
@@ -25,5 +25,4 @@
 using System.Reflection;
 using System.Reflection.Emit;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Persistence {
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj	(revision 14927)
@@ -48,5 +48,7 @@
   <ItemGroup>
     <Compile Include="Core\ComponentInfo.cs" />
+    <Compile Include="Core\DataMemberAccessor.cs" />
     <Compile Include="Core\Index.cs" />
+    <Compile Include="Core\PersistenceException.cs" />
     <Compile Include="Core\StaticCache.cs" />
     <Compile Include="Core\Mapper.cs" />
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ISerializer.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ISerializer.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ISerializer.cs	(revision 14927)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Persistence {
+  [StorableType("81ac6e7f-1a3e-4a60-a146-c407104c02ca")]
   public interface ISerializer {
     void Serialize(object o, Stream stream);
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ITransformer.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ITransformer.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/ITransformer.cs	(revision 14927)
@@ -23,4 +23,5 @@
 
 namespace HeuristicLab.Persistence {
+  [StorableType("51aec2b4-6e18-4e6d-b00b-ee656747be78")]
   public interface ITransformer {
     Guid Guid { get; }
Index: branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/StorableClassTransformer.cs
===================================================================
--- branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/StorableClassTransformer.cs	(revision 14926)
+++ branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Transformers/StorableClassTransformer.cs	(revision 14927)
@@ -24,8 +24,8 @@
 using System.Linq;
 using System.Reflection;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Persistence {
   [Transformer("78556C88-0FEE-4602-95C7-A469B2DDB468", 100)]
+  [StorableType("3a578289-43ca-40f8-9f1e-2bdd255cb8fb")]
   internal sealed class StorableClassBoxTransformer : BoxTransformer<object> {
     public override bool CanTransformType(Type type) {
@@ -89,5 +89,5 @@
         dict.Add(mapper.GetString(component.Key), mapper.GetObject(component.Value));
       }
-      
+
       // TODO: check that all entries in the dictionary can be mapped to a field or property
       foreach (var convMeth in conversionMethods) {
